/*====================================================================*
 -  Copyright (C) 2001 Leptonica.  All rights reserved.
 -  This software is distributed in the hope that it will be
 -  useful, but with NO WARRANTY OF ANY KIND.
 -  No author or distributor accepts responsibility to anyone for the
 -  consequences of using this software, or for whether it serves any
 -  particular purpose or works at all, unless he or she says so in
 -  writing.  Everyone is granted permission to copy, modify and
 -  redistribute this source code, for commercial or non-commercial
 -  purposes, with the following restrictions: (1) the origin of this
 -  source code must not be misrepresented; (2) modified versions must
 -  be plainly marked as such; and (3) this notice may not be removed
 -  or altered from any source or modified source distribution.
 *====================================================================*/

#ifndef  ARRAY_H
#define  ARRAY_H

#define   WORD_SUBSTRING     1
#define   LINE_SUBSTRING     2


struct Numaa
{
    INT32            nalloc;    /* size of allocated ptr array         */
    INT32            n;         /* number of Numa saved                */
    struct Numa    **numa;      /* array of Numa                       */
};
typedef struct Numaa  NUMAA;


struct Numa
{
    INT32            nalloc;    /* size of allocated number array      */
    INT32            n;         /* number of numbers saved             */
    INT32            refcount;  /* reference count (1 if no clones)    */
    FLOAT32         *array;     /* number array                        */
};
typedef struct Numa  NUMA;


struct StringArray
{
    INT32            nalloc;    /* size of allocated ptr array         */
    INT32            n;         /* number of strings allocated         */
    char           **array;     /* string array                        */
};
typedef struct StringArray SARRAY;


#endif  /* ARRAY_H */
