/*header file for asymmetry.c, contains functions for calculating and evaluating
 *the asymmetry in each lane*/


/*header file for asymmetry.h, contains function to calculate, sort and evaluate the asymmetry score in each lane*/

#ifndef ASYMMETRY_H
#define ASYMMETRY_H

#include "allheaders.h"
#include "gelinfo.h"
#include "anacutoff.h"
#define TOLERANCEFACTOR 3.0

int checkSymmetry(FILE *ERROROUT_FILE, FILE *FLAGOUT_FILE, PIX *pixGel, int* ZoneID, float **PeakPosition, float *NodePosition, struct GelInfo *GelInfo, struct AnaCutoff *AnaCutoff, float **Asym, float **Laneoffset, int *con_asym_lanes, int Verbose); 
int correctAsymmetry(INT32 **ZoneProjection, float **PeakPosition, float *Spacing, struct GelInfo *GelInfo, float **Asym, int MarkerInc); 

void followLane(PIX *pixGel, float **PeakPosition, float *NodePosition, struct GelInfo *GelInfo, int laneID, float **laneintensity);
void shellSort(float numbers[], int array_size);

#endif
