/*header file for checkresult.h, contain functions to check peak positon, 
 *marker correlation and roughness and subsequent correction
 */

#ifndef CHECKRESULT_H
#define CHECKRESULT_H

#include "allheaders.h"
#include "gelinfo.h"
#include "anacutoff.h"

#define SIGMA_CUTOFF 4
#define FWHM_FACTOR 5.0/9.0
#define TOLERANCEFACTOR 3.0

void checkPeakPositions(FILE *ERROROUT_FILE, FILE *FLAGOUT_FILE, float **PeakPosition, float *Spacing, int Markerinc, struct GelInfo *GelInfo, struct AnaCutoff *AnaCutoff,int *num_interpolated_markers, int *num_interpolated_data, int *con_interpolated_markers, int *con_interpolated_data, int Verbose);
void checkMarkers(FILE *ERROROUT_FILE, FILE *FLAGOUT_FILE, PIX *pixGelin, float **PeakPosition, float *NodePosition, int *ZoneID, struct GelInfo *GelInfo, struct AnaCutoff *AnaCutoff, float **MarkerCorrelation, float **MarkerRoughness, int Verbose);
void matchSinglePeak(INT32 **ZoneProjection, struct GelInfo *GelInfo, float **PeakPosition, int zoneID, int laneID);
int correctMarkers(FILE *FLAGOUT_FILE, INT32 **ZoneProjection, float **PeakPosition, struct GelInfo *GelInfo, struct AnaCutoff *AnaCutoff, float **MarkerCorrelation, int Verbose);
#endif
