#include <stdio.h>
#include <stdlib.h>
#include "mapto8bits.h"

/*Map a 16bit pix to an 8bit pix maximizing the dynamic range of the image
 *in the process
 */
PIX *pixMapTo8bits (FILE *FLAGOUT_FILE, PIX *pixGelRaw, struct GelInfo *GelInfo, int Verbose) {

UINT8	dval;
UINT16	min16, max16, sval16;
INT32	i, j;
UINT32	word;
UINT32	*lines, *lined;
UINT32	*datas, *datad;
INT32	wpls, wpld;
FLOAT32	slope, intercept;
PIX	*pixGel8bits;

  if ((pixGel8bits = pixCreate(GelInfo->ImageWidth, GelInfo->ImageHeight, 8)) == NULL) {
    fprintf(stderr,"Cannot create 8 bit image!\n");
    exit(1);
  }
  datas = pixGetData(pixGelRaw);
  wpls = pixGetWpl(pixGelRaw);
  datad = pixGetData(pixGel8bits);
  wpld = pixGetWpl(pixGel8bits);
  max16 = 0;
  min16 = 0xffff;
  for (i = 0; i < GelInfo->ImageHeight; i++) {
    lines = datas + i * wpls;
    for (j = 0; j < wpls; j++) {
      word = *(lines + j);
      max16 = MAX(max16, word >> 16);
      max16 = MAX(max16, word & 0xffff);
      min16 = MIN(min16, word >> 16);
      min16 = MIN(min16, word & 0xffff);
    }
  }
  if (Verbose) fprintf(stderr, "Raw image: minimum = %d, maximum = %d\n",min16,max16);
  fprintf(FLAGOUT_FILE, "Raw image maximum:\t%d\nRaw image minimum:\t%d\n",min16, max16);
  slope = 255 / (FLOAT32)(max16-min16);
  intercept = -1 * slope * min16;
  for (i = 0; i < GelInfo->ImageHeight; i++) {
    lines = datas + i * wpls;
    lined = datad + i * wpld;
    for (j = 0; j < GelInfo->ImageWidth; j++) {
      sval16 = GET_DATA_TWO_BYTES(lines, j);
      dval = (UINT8)(slope * (FLOAT32)sval16 + intercept);
      SET_DATA_BYTE(lined, j, dval);
     }
   }
    return pixGel8bits;
}

