/*contains function for a 3x3 then 1x9 median filter for PIX*/

#include <stdio.h>
#include <stdlib.h>
#include "medianfilter.h"

#define PIX_SORT(a,b) { if ((a)>(b)) PIX_SWAP((a),(b)); }
#define PIX_SWAP(a,b) { UINT8 temp=(a);(a)=(b);(b)=temp; }
static UINT8 opt_med9(UINT8 *p) {
    PIX_SORT(p[1], p[2]) ; PIX_SORT(p[4], p[5]) ; PIX_SORT(p[7], p[8]) ;
    PIX_SORT(p[0], p[1]) ; PIX_SORT(p[3], p[4]) ; PIX_SORT(p[6], p[7]) ;
    PIX_SORT(p[1], p[2]) ; PIX_SORT(p[4], p[5]) ; PIX_SORT(p[7], p[8]) ;
    PIX_SORT(p[0], p[3]) ; PIX_SORT(p[5], p[8]) ; PIX_SORT(p[4], p[7]) ;
    PIX_SORT(p[3], p[6]) ; PIX_SORT(p[1], p[4]) ; PIX_SORT(p[2], p[5]) ;
    PIX_SORT(p[4], p[7]) ; PIX_SORT(p[4], p[2]) ; PIX_SORT(p[6], p[4]) ;
    PIX_SORT(p[4], p[2]) ; return(p[4]) ;
}

/*
 * apply a 3x3 median filter followed by a 9x1 median filter
 */
PIX *pixMedianFilter (PIX *pixGel8bits, struct GelInfo *GelInfo) {

INT32	i, j, im, jm, index;
UINT8	vector[9], median;
UINT32	*lines, *lined;
UINT32	*datas, *datad;
INT32	wpls, wpld;
PIX	*pixGelFilter, *pixWithBorder;

  if ((pixGelFilter = pixCreate(GelInfo->ImageWidth, GelInfo->ImageHeight, 8)) == NULL) {
    fprintf(stderr,"Cannot create 8 bit filtered image!\n");
    exit(1);
  }
  pixWithBorder = pixAddBorder(pixGel8bits, 1, 0);
  datas = pixGetData(pixWithBorder);
  wpls = pixGetWpl(pixWithBorder);
  datad = pixGetData(pixGelFilter);
  wpld = pixGetWpl(pixGelFilter);
  for (i = 0; i < GelInfo->ImageHeight; i++) {
    lined = datad + i * wpld;
    for (j = 0; j < GelInfo->ImageWidth; j++) {
      index = 0;
      for (im = i; im < i+3; im++) {
        lines = datas + im * wpls;
	for (jm = j; jm < j+3; jm++) { 
          vector[index] = GET_DATA_BYTE(lines, jm);
	  index++;
	}
      }
      median = opt_med9(vector);
      SET_DATA_BYTE(lined, j, median);
    }
  } 
  
  pixDestroy(&pixWithBorder);
  pixWithBorder = pixAddBorder(pixGelFilter, 4, 0);
  datas = pixGetData(pixWithBorder);
  wpls = pixGetWpl(pixWithBorder);
  datad = pixGetData(pixGelFilter);
  wpld = pixGetWpl(pixGelFilter);
  for (i = 0; i < GelInfo->ImageHeight; i++) {
    lines = datas + (i+4) * wpls;
    lined = datad + i * wpld;
    for (j = 0; j < GelInfo->ImageWidth; j++) {
      index = 0;
      for (jm = j; jm < j+9; jm++) { 
        vector[index] = GET_DATA_BYTE(lines, jm);
	index++;
      }
      median = opt_med9(vector);
      SET_DATA_BYTE(lined, j, median);
    }
  }

  pixDestroy(&pixWithBorder);   
  return pixGelFilter;
}
