/*header file for position.c, contains functions for peak matching and curvature calculations and output*/

#ifndef POSITION_H
#define POSITION_H

#include "allheaders.h"
#include "gelinfo.h"

#define SIGMA_CUTOFF 4
#define FWHM_FACTOR 5.0/9.0
#define TOLERANCEFACTOR 3.0
#define MAXCURVATUREFACTOR 1.6

int findPeakPosition (FILE *FLAGOUT_FILE, float **PeakPosition, INT32 **ZoneProjection, struct GelInfo *GelInfo, float *Spacing, float minpsizefactor, int Markerinc, int Verbose); 
void writeCurvature(FILE *FLAGOUT_FILE, float **PeakPosition, float *NodePosition, struct GelInfo *GelInfo); 
int correctOutlierPeaks(float **PeakPosition, float *NodePosition, struct GelInfo *GelInfo, int Verbose); 
void smoothPeaks(float **PeakPosition, struct GelInfo *GelInfo, int Verbose); 
void fillEmpties(float *PeakPosition, struct GelInfo *GelInfo);

#endif
