/*header file for zone.c, contains functions related to the initialization of zone boundary and nodes, and zoneprojection operations*/

#ifndef ZONE_H
#define ZONE_H

#define WELLWINDOWFACTOR 60
#define FINDMAXFACTOR 5
#define PREDATAFACTOR 1.1
#define POSTDATAFACTOR 1.05
#define FIXFLATFACTOR 2.5
#define SMOOTHROUNDS 2
#define SHIFTTOFIT32 8
#define PREDATASTOPFACTOR 0.8
#define STOPDATASTEPBACKFACTOR 0.25
#define MINZONESIZEFACTOR 4.0

#include "allheaders.h"
#include "gelinfo.h"

void initZones (FILE *FLAGOUT_FILE, PIX *pixGel, struct GelInfo *GelInfo, int *ZoneID, int Verbose); 
void projectZones (PIX *pixGel, INT32 **ZoneProjection, struct GelInfo *GelInfo, int *ZoneID);
void filterZoneProjection (INT32 **ZoneProjection, struct GelInfo *GelInfo, float *Spacing); 
void setNodePositions (PIX *pixGel, struct GelInfo *GelInfo, int *ZoneID, float *NodePosition, int Verbose); 

#endif
